; -*- emacs-lisp -*-
;
; .emacsrc package
; Serge Olkhowik (aka BaMba)
;
; c/c++ mode
;
; $RCSfile: mode-c.el $
; $Revision: 1.7 $ $Date: 2002/04/21 18:17:35 $
;
; $Log: mode-c.el $
; Revision 1.7  2002/04/21 18:17:35  solo
; fix: rcs  
;
; Revision 1.6  2002/04/21 17:52:46  solo
;   break
;
; Revision 1.5  2002/04/21 17:50:10  solo
;   ++
;
; Revision 1.4  2002/04/21 17:48:58  solo
; fix: rcs     
;
; Revision 1.3  2002/04/21 17:39:58  solo
; fix: coding
;
; Revision 1.2  2002/04/21 17:38:51  solo
;    
;     
;
; Revision 1.1  2002/02/23 12:15:05  serge
; Initial revision
;

(add-hook 'c-mode-common-hook 'so-minor-modes)
(add-hook 'find-file-not-found-hooks 'so-new-c)
(add-hook 'find-file-not-found-hooks 'so-new-cc)

(defun so-new-c ()
  (let ((f-name (buffer-file-name)))
    (if (or (string-match "\\.c$" f-name) (string-match "\\.h$" f-name))
	(insert "/* -*- c -*-\n"
		" * File    " (file-name-nondirectory f-name) "\n"
		" * Created " (current-time-string) "\n"
		" *\n"
		" *\n"
		" * $" "RCSfile: " "$\n"
		" * $" "Revision: " "$ $" "Date: " "$\n"
		" *\n"
		" * $" "Log: " "$\n"
		" *\n"))))

(defun so-new-cc ()
  (let ((f-name (buffer-file-name)))
    (if (or (string-match "\\.cpp$" f-name) (string-match "\\.hpp$" f-name))
	(insert "// -*- C++ -*-\n"
		"// File    " (file-name-nondirectory f-name) "\n"
		"// Created " (current-time-string) "\n"
		"//\n"
		"//\n"
		"// $" "RCSfile: " "$\n"
		"// $" "Revision: " "$ $" "Date: " "$\n"
		"//\n"
		"// $" "Log: " "$\n"
		"//\n"))))


;; (define-abbrev-table 'c-mode-abbrev-table
;;   '(("#i" "#include" c-electric-continued-statement 0)
;;     ("#d" "#define" c-electric-continued-statement 0)
;;     ("#e" "#endif" c-electric-continued-statement 0)
;;     ("wh" "while" c-electric-continued-statement 0)))

(define-abbrev-table 'c++-mode-abbrev-table
  '(("#i" "#include" c-electric-continued-statement 0)
    ("#d" "#define" c-electric-continued-statement 0)
    ("#e" "#endif" c-electric-continued-statement 0)
    ("vo" "void" nil 0)
    ("co" "const" nil 0)
    ("wh" "while" c-electric-continued-statement 0)
    ("sw" "switch" c-electric-continued-statement 0)
    ("ca" "case" c-electric-continued-statement 0)
    ("br" "break" c-electric-continued-statement 0)
    ("xi" "FXint" c-electric-continued-statement 0)
    ("xf" "FXfloat" c-electric-continued-statement 0)
    ("xs" "FXString" c-electric-continued-statement 0)
    ("xo" "FXObject" c-electric-continued-statement 0)
    ("xse" "FXSelector" c-electric-continued-statement 0)
    ("xl" "FXLabel" c-electric-continued-statement 0)
    ("xt" "FXTextField" c-electric-continued-statement 0)
    ("xh" "FXHorizontalFrame" c-electric-continued-statement 0)
    ("xv" "FXVerticalFrame" c-electric-continued-statement 0)))

;; Local Variables:
;; buffer-file-coding-system: koi8-r
;; End:
